Summary: Glide runtime for 3Dfx Voodoo Banshee and Voodoo3 boards
Name: Glide_V3
Version: 2.60.15
Release: 7mdk
Source: GlideV3.tar.bz2
URL: http://www.3dfx.com	
Copyright: 3DFX GLIDE Source Code General Public License
Group: System/Libraries
BuildRequires: XFree86-devel
Prefix: /usr
BuildRoot: %{_tmppath}/Glide
ExclusiveArch: i386 i486 i586 i686 k6 k7

%description 
This package now includes both Glide2x and Glide3x.  Glide is a
lowlevel API for accessing 3dfx Interactive's Voodoo Hardware.  This
version of Glide supports Voodoo Banshee and Voodoo3 based 3D
acclerators.

%package devel
Summary: Development libraries for Glide 2.x
Group: Development/C

%description devel
This package includes the header files, documentation, and test files
necessary for developing applications that use any of the 3D acceleratos in 
the 3Dfx Interactive Voodoo line.

%prep
%setup -c
chmod +x GlideV3/swlibs/include/make/ostype

%build

# A lot of people don't have the compatibility tools/libs installed and
# don't want to build the compat libraries.  However I want to build the
# compat libraries for official 3dfx builds so it gets triggered by
# an env variable.  Resetting to GO and TRUE are used by the Makefile
# to control the buidling of glide2x and not glide3x

if [ "$GLIDE_BUILD_COMPAT" = "TRUE" ]; then
export CC=i386-glibc20-linux-gcc
export GLIDE_BUILD_COMPAT=GO
make -C GlideV3 V3_NODRI

# Save the compat libraries for the install section
mv GlideV3/glide2x/h3/lib/libglide.so.2 \
  GlideV3/glide2x/h3/lib/libglide2x.glibc20
mv GlideV3/swlibs/lib/libtexus.so.1.1 GlideV3/swlibs/lib/libtexus.glibc20

# Clean up the compat build
make -C GlideV3 clean_V3

# Reset this so that other checks pass
export GLIDE_BUILD_COMPAT=TRUE

# Unset CC so it goes back to the default
unset CC
fi

# Now build for native compiler unconditionally
make -C GlideV3 V3_NODRI

%install
rm -rf $RPM_BUILD_ROOT

######################################################################
# Create directories
######################################################################

install -d -m 755 $RPM_BUILD_ROOT%{_libdir}
install -d -m 755 $RPM_BUILD_ROOT%{_bindir}
install -d -m 755 $RPM_BUILD_ROOT%{_includedir}
install -d -m 755 $RPM_BUILD_ROOT%{_includedir}/glide
install -d -m 755 $RPM_BUILD_ROOT%{_includedir}/glide3
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/Glide2
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/Glide3
if [ "$GLIDE_BUILD_COMPAT" = "TRUE" ]; then
install -d -m 755 $RPM_BUILD_ROOT/usr/i386-glibc20-linux/lib
fi

######################################################################
# Install the Glide2x libraries
######################################################################

# Install the native libraries normally
install -m 755 GlideV3/glide2x/h3/lib/libglide.so.2.60 \
  $RPM_BUILD_ROOT%{_libdir}/libglide.so.2.60

# Create symlinks
rm -f $RPM_BUILD_ROOT%{_libdir}/libglide.so.2
ln -s libglide.so.2.60 $RPM_BUILD_ROOT%{_libdir}/libglide.so.2

rm -f $RPM_BUILD_ROOT%{_libdir}/libglide.so
ln -s libglide.so.2.60 $RPM_BUILD_ROOT%{_libdir}/libglide.so

# Create a compatibility link for the old name
rm -f $RPM_BUILD_ROOT%{_libdir}/libglide2x.so
ln -s libglide.so.2.60 $RPM_BUILD_ROOT%{_libdir}/libglide2x.so

rm -f $RPM_BUILD_ROOT%{_libdir}/libglide2x.so.2
ln -s libglide.so.2.60 $RPM_BUILD_ROOT%{_libdir}/libglide2x.so.2

######################################################################
# Install the Compat Libraries in the compat directory
######################################################################
echo >  compat
if [ "$GLIDE_BUILD_COMPAT" = "TRUE" ]; then
# The compat libs just need the old name, so I don't need to use the new
# naming scheme.
install -m 755 GlideV3/glide2x/h3/lib/libglide2x.glibc20 \
  $RPM_BUILD_ROOT%{prefix}/i386-glibc20-linux/lib/libglide2x_V3.so
rm -f $RPM_BUILD_ROOT%{prefix}/i386-glibc20-linux/lib/libglide2x.so
ln -s libglide2x_V3.so \
  $RPM_BUILD_ROOT%{prefix}/i386-glibc20-linux/lib/libglide2x.so
install -m 755 GlideV3/swlibs/lib/libtexus.glibc20 \
  $RPM_BUILD_ROOT%{prefix}/i386-glibc20-linux/lib/libtexus.so

# This part is a bit of a pain.  The %files section of the spec isn't shell 
# script so I can't make it conditional on $GLIDE_BUILD_COMPAT.  I can 
# include a file, so I write the compat file names to a file.
echo %{prefix}/i386-glibc20-linux/lib/libglide2x_V3.so >  compat
echo %{prefix}/i386-glibc20-linux/lib/libglide2x.so    >> compat
echo %{prefix}/i386-glibc20-linux/lib/libtexus.so      >> compat
fi

######################################################################
# Install the Glide3X libraries
######################################################################
install -m 755 GlideV3/glide3x/h3/lib/libglide3.so.3.10 \
  $RPM_BUILD_ROOT%{_libdir}/libglide3.so.3.10
rm -f $RPM_BUILD_ROOT%{_libdir}/libglide3x.so

# Create symlinks
rm -f $RPM_BUILD_ROOT%{_libdir}/libglide3.so.3
ln -s libglide3.so.3.10 $RPM_BUILD_ROOT%{_libdir}/libglide3.so.3

rm -f $RPM_BUILD_ROOT%{_libdir}/libglide3.so
ln -s libglide3.so.3.10 $RPM_BUILD_ROOT%{_libdir}/libglide3.so

# Create a compatibility link for the old name
rm -f $RPM_BUILD_ROOT%{_libdir}/libglide3x.so
ln -s libglide3.so.3.10 $RPM_BUILD_ROOT%{_libdir}/libglide3x.so

rm -f $RPM_BUILD_ROOT%{_libdir}/libglide3x.so.3
ln -s libglide3.so.3.10 $RPM_BUILD_ROOT%{_libdir}/libglide3x.so.3

######################################################################
# Install Texus
######################################################################
install -m 755 GlideV3/swlibs/lib/libtexus.so.1.1 $RPM_BUILD_ROOT%{_libdir}

rm -f $RPM_BUILD_ROOT%{_libdir}/libtexus.so.1
ln -s libtexus.so.1.1 $RPM_BUILD_ROOT%{_libdir}/libtexus.so.1

rm -f $RPM_BUILD_ROOT%{_libdir}/libtexus.so
ln -s libtexus.so.1 $RPM_BUILD_ROOT%{_libdir}/libtexus.so

install -m 755 GlideV3/swlibs/bin/texus $RPM_BUILD_ROOT%{_bindir}


######################################################################
# Install the Glide2x SDK material
######################################################################

# Install the headers
install -m 644 GlideV3/swlibs/include/3dfx.h $RPM_BUILD_ROOT%{_includedir}/glide
install -m 644 GlideV3/glide2x/h3/include/glide.h \
  $RPM_BUILD_ROOT%{_includedir}/glide
install -m 644 GlideV3/glide2x/h3/include/glidesys.h \
  $RPM_BUILD_ROOT%{_includedir}/glide
install -m 644 GlideV3/glide2x/h3/include/glideutl.h \
  $RPM_BUILD_ROOT%{_includedir}/glide
install -m 644 GlideV3/glide2x/h3/include/sst1vid.h \
  $RPM_BUILD_ROOT%{_includedir}/glide
install -m 644 GlideV3/glide2x/h3/include/gump.h \
  $RPM_BUILD_ROOT%{_includedir}/glide
install -m 644 GlideV3/swlibs/include/linutil.h \
  $RPM_BUILD_ROOT%{_includedir}/glide
install -m 644 GlideV3/swlibs/include/texus.h \
  $RPM_BUILD_ROOT%{_includedir}/glide

# Install the documentation
install -m 644 GlideV3/glide_license.txt $RPM_BUILD_ROOT%{_docdir}/Glide2
install -m 644 GlideV3/docs2x/*.pdf $RPM_BUILD_ROOT%{_docdir}/Glide2


######################################################################
# Install the Glide3x SDK material
######################################################################
# Install the headers
install -m 644 GlideV3/swlibs/include/3dfx.h \
  $RPM_BUILD_ROOT%{_includedir}/glide3
install -m 644 GlideV3/glide3x/h3/include/glide.h \
  $RPM_BUILD_ROOT%{_includedir}/glide3
install -m 644 GlideV3/glide3x/h3/include/glidesys.h \
  $RPM_BUILD_ROOT%{_includedir}/glide3
install -m 644 GlideV3/glide3x/h3/include/glideutl.h \
  $RPM_BUILD_ROOT%{_includedir}/glide3
install -m 644 GlideV3/glide3x/h3/include/sst1vid.h \
  $RPM_BUILD_ROOT%{_includedir}/glide3
install -m 644 GlideV3/swlibs/include/linutil.h \
  $RPM_BUILD_ROOT%{_includedir}/glide3
install -m 644 GlideV3/swlibs/include/texus.h \
  $RPM_BUILD_ROOT%{_includedir}/glide3


# Install the examples and their source
# Make two copies so that the old test3Dfx is still there and
# we now have a consisten testGlide2x, testGlide3x

install -m 755 GlideV3/glide2x/h3/glide/tests/test00 \
$RPM_BUILD_ROOT%{_bindir}/test3Dfx

install -m 755 GlideV3/glide2x/h3/glide/tests/test00 \
$RPM_BUILD_ROOT%{_bindir}/testGlide2x

install -m 755 GlideV3/glide3x/h3/glide3/tests/test00 \
$RPM_BUILD_ROOT%{_bindir}/testGlide3x


# Install the documentation
install -m 644 GlideV3/glide_license.txt $RPM_BUILD_ROOT%{_docdir}/Glide3
install -m 644 GlideV3/docs3x/*.pdf $RPM_BUILD_ROOT%{_docdir}/Glide3

%clean
rm -rf $RPM_BUILD_ROOT


# This will remove the very old Glide SDK that installed things in 
%post
/sbin/ldconfig

%post devel
/sbin/ldconfig

%postun
/sbin/ldconfig

%files -f compat
%defattr(-,root,root)
%docdir %{_docdir}/Glide2
%docdir %{_docdir}/Glide3
%{_docdir}/Glide2/glide_license.txt
%{_docdir}/Glide3/glide_license.txt
%{_libdir}/libglide.so.*
%{_libdir}/libglide2x.so.*
%{_libdir}/libglide3.so.*
%{_libdir}/libglide3x.so.*
%{_libdir}/libtexus.so.1.1
%{_libdir}/libtexus.so.1
%{_bindir}/texus
%{_bindir}/test3Dfx
%{_bindir}/testGlide3x
%{_bindir}/testGlide2x

%files devel
%defattr(-,root,root)
%{_libdir}/libglide.so
%{_libdir}/libglide2x.so
%{_libdir}/libglide3x.so
%{_libdir}/libglide3.so
%{_libdir}/libtexus.so
%docdir %{_docdir}/Glide2
%docdir %{_docdir}/Glide3
%{_docdir}/Glide2/glidepgm.pdf
%{_docdir}/Glide2/glideref.pdf
%{_docdir}/Glide3/glide3pgm.pdf
%{_docdir}/Glide3/glide3ref.pdf
%{_docdir}/Glide3/glide3relno.pdf
%dir %{_includedir}/glide
%{_includedir}/glide/*
%dir %{_includedir}/glide3
%{_includedir}/glide3/*

%changelog
* Thu Oct 05 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 2.60.15-7mdk
- fix dangling symlink.

* Sun Sep 24 2000 Stefan van der Eijk <s.vandereijk@chello.nl> 2.60.15-6mdk
- macro's + BM

* Mon Aug 07 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.60.15-5mdk
- automatically added BuildRequires

* Mon May 15 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 2.60.15-4mdk
- ExclusiveArch: i386 i486 i586 i686 k6 k7

* Tue Apr 18 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 2.60.15-3mdk
- Cleaned up the spec file.
- Stuff are installed in a cleaner way.

* Thu Apr 13 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 2.60.15-2mdk
- fix group
- correct file in devel package.
- fix attr

* Wed Mar 23 2000 Yoann Vandoorselaere <yoann@mandrakesoft.com> 2.60.15-1mdk
- Mandrake package.
- Fix group.

* Wed Feb 23 2000 Joseph Kain <joseph@3dfx.com>
- Revision 15
- Fix to minihwc to stop crashing on reinitialization

* Tue Feb 15 2000 Joseph Kain <joseph@3dfx.com>
- Revision 14
- Fix to the pci library that unmaps boards correctly on shutdown
- Source now supports FreeBSD

* Fri Feb 04 2000 Joseph Kain <joseph@3dfx.com>
- Fixed typo that messed up compatbility symlinks for glide3
- Added libglide3x.so.3 and libglide2x.so.2 that were missing from %files

* Mon Jan 31 2000 Joseph Kain <joseph@3dfx.com>
- Finished making compat build completely optional

* Wed Jan 19 2000 Joseph Kain <joseph@3dfx.com>
- Merged Glide2x and Glide3x kits into a single package.

* Thu Jan 13 2000 Joseph Kain <joseph@3dfx.com>
- Made building compat libraries (for glibc2.0) optional

* Tue Nov 30 1999 Joseph Kain <joseph@3dfx.com>
- Built against initial source release
